<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2010 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <vitaly.hohlov@gmail.com>
 * @package Blocks
 */
/**************************************************************************/

/**
 * Блок "Список вопросов".
 *
 * <a href="http://wiki.a-cms.ru/blocks/faq">Руководство</a>.
 */

class faq_Block extends A_Block
{
/**
 * Формирование данных доступных в шаблоне.
 */

  function createData()
  {
	if($this->params['sort']!=4)
	$this->supportCached();

	$this->params['idcat']=(integer)$this->params['idcat'];

	if($this->params['idcat']>0)
	{ $catrow=A::$DB->getRowById($this->params['idcat'],"{$this->section}_categories");
	  $catrow['link']=faq_createCategoryLink($this->params['idcat'],$this->section);
	  $this->Assign("category",$catrow);
	}

	switch($this->params['sort'])
	{ default:
	  case 1: $sort="date DESC"; break;
	  case 2: $sort="date"; break;
	  case 3: $sort="name"; break;
	  case 4: $sort="RAND()"; break;
	}

	if($this->params['rows']>0)
	A::$DB->queryLimit("
	SELECT * FROM {$this->section}_catalog
	WHERE active='Y'".($this->params['idcat']>0?" AND idcat={$this->params['idcat']}":"")."
	ORDER BY $sort",0,(integer)$this->params['rows']);
	else
	A::$DB->query("
	SELECT * FROM {$this->section}_catalog
	WHERE active='Y'".($this->params['idcat']>0?" AND idcat={$this->params['idcat']}":"")."
	ORDER BY $sort");

    $items=array();
	while($row=A::$DB->fetchRow())
    { if($row['idcat']>0)
	  $row['category']=getTreePath($this->section."_categories",$row['idcat']);
	  $row['link']=faq_createItemLink($row['id'],$this->section);
	  prepareValues($this->section,$row);
      $items[]=$row;
    }
	A::$DB->free();

	$this->Assign("items",$items);
	$this->Assign("questionlink",$this->sectionlink."question.html");
  }
}